/*
  "Rollladeneffekt" by Adok
  Public Domain
*/

#include <stdio.h>
#include <conio.h>

//Bildschirmmodus einstellen
void screen(unsigned int nr)
{
  asm {
    mov ax,nr
    int 0x10
  }
}

//Auf vertikalen Retrace warten
void waitretrace(void)
{
 while( (inp(0x3da)&8)!=0 );
 while( (inp(0x3da)&8)==0 );
}

void main()
{
  unsigned char i;

  screen(3);

  //Der Effekt
  for(i=0;i<=15;i++)
  {
    asm {
      mov dx,0x3d4
      mov al,9
      out dx,al
      mov dx,0x3d5
      in al,dx
      mov ah,al
      and ah,224
      mov al,i
      or al,ah
      out dx,al
    }

    /*
      Wir warten 4mal auf den vertikalen Retrace, damit man den Effekt
      deutlich erkennt
      Fr die praktische Verwendung mindestens zwei waitretrace()-Aufrufe
      entfernen!
    */
    waitretrace();
    waitretrace();
    waitretrace();
    waitretrace();

    //Beim ersten Durchlauf Text anzeigen
    if(!i)
    {
      printf("Dies ist der aus dem Diskmag Suicide bekannte Rollladeneffekt."
             "\nEr ist *sehr* kurz und sieht ganz nett aus.\nDieses "
             "Beispielprogramm ist Public Domain.\n\nDas Wort \"Rollladen\" "
             "schreibt man brigens auch nach der alten Rechtschreibung\nmit "
             "drei l. :)");
    }
  }
  getch();

  screen(3);
}
