Program EasySB;
Uses Dos,Crt;

Const SBPort : Word = $240;
      FN     : String = '8B.WAV';
      KHz    : Byte = 22;

Var TimSpeed : Word;
    PlayEnd  : Boolean;
    IntReady : Boolean;
    NormProc : Procedure;
    Insgs    : Word;
    APos     : Word;
    SPtr     : Pointer;

Procedure ResetSB;
Begin
Port[SBPort+4]:=0;
Port[SBPort+5]:=0;
Port[SBPort+6]:=0;
Port[SBPort+$C]:=$D1;
End;

Procedure DSPReady;
Begin
While (Port[SBPort+$0C] and 128)=128 do;
end;

Procedure Play; Interrupt;
Var B:Byte;
Begin
If APOS>=Insgs Then PlayEnd:=True;
If PlayEnd Then Exit;  {Wenn SoundPlaying zuende stop}
Inc(APos); {Datenposition ndern}
If not IntReady Then Exit; {Schutz vor berlauf}
IntReady:=False;
B:=Mem[Seg(SPtr^):Ofs(SPtr^)+APOS];
DSPReady; {Warten, bis DSP fertig}
Port[SBPort+$C]:=$10; {Zur direkten Ausgabe bereit machen}
DSPReady; {Warten, bis DSP fertig}
Port[SBPort+$C]:=B; {Byte ausgeben}
IntReady:=True;
End;

Procedure PlayBuffer(P : Pointer; Howm : Word);
Begin
TimSpeed:=60;
Case KHz of
  22 : TimSpeed:=60; {22 KHz}
  11 : TimSpeed:=120; {11 KHz}
End;
{Die Ausgabe mit einer Qualitt von 44 KHz ist meiner Erfahrung nach
 nicht mglich, in diesem Fall mu man die Frequenz auf 22 KHz setzen
 und jede zweite Soundinformation berspringen}
GetIntVec($1C,@NormProc);
Port[$43]:=$36;               {diesen auf Zhler 0 programmieren}
Port[$40]:=Lo(TimSpeed);
Port[$40]:=Hi(TimSpeed);
IntReady:=True;
PlayEnd:=False;
SPtr:=P;
Insgs:=Howm;
APOS:=0;
SetIntVec($1C,@PLAY);
End;

Procedure StopPlay;
Begin
SetIntVec($1C,@NormProc);
Port[$43]:=$36;               {diesen auf Zhler 0 programmieren}
Port[$40]:=0;
Port[$40]:=0;
End;

Var F : File;
    P : Pointer;
    HowmR : Word;


Begin
ResetSB;
Assign(F,FN);
Reset(F,1);
Seek(F,44);
GetMem(P,65535);
BlockRead(F,P^,65535,HowmR);
PlayBuffer(P,HowmR);
Repeat
Until PlayEnd;
StopPlay;
FreeMem(P,65535);
{Die Datei befindet sich im Verzeichnis ?}
End.
